<?php

namespace Moneris\Checkout;

class Api
{
    public function execute()
    {
        $endpoint = sanitize_title($_GET['type']);

        switch ($endpoint) {
            case 'pay':
                $this->pay();
                break;
            case 'getticket':
                $this->getticket();
                break;
        }
    }

    private function getticket() {
        $ticket = new \Moneris\Checkout\Ticket();
        $ticketData = $ticket->getTicket();

        echo wp_json_encode([
            'success' => true,
            'data' => $ticketData,
        ]);
    }

    private function pay()
    {
        $helper = new Helper\Data();
        $helper->log("Pay action called");
        $ticketID = sanitize_text_field($_REQUEST['ticket']);
        $ticket = new Ticket();
        $body = $ticket->getReceiptData($ticketID);
        $helper->log('Receipt ' . json_encode($body));

        if ($body['response']['success'] === "true") {
            if (
                $body['response']['receipt']['cc']['amount'] === 'null' ||
                !isset($body['response']['receipt']['cc']['approval_code']) ||
                !isset($body["response"]["receipt"]["cc"]["result"]) ||
                $body["response"]["receipt"]["cc"]["result"] === 'd' ||
                $body["response"]["receipt"]["cc"]["approval_code"] === 'null'
            ) {
                wp_send_json([
                    'success' => false,
                    'message' => __('Please try again'),
                    'data' => $body['response'],
                ]);
            }

            // Generate order

            wp_send_json([
                'success' => true,
                'data' => $body['response'],
            ]);
        } else {
            wp_send_json([
                'success' => false,
                'message' => __('Get receipt request failed'),
            ]);
        }
    }

    /**
     * @param $address
     */
    public function calculate_shipping($address) {
        try {
            WC()->shipping()->reset_shipping();

            $address = apply_filters( 'woocommerce_cart_calculate_shipping_address', $address );

            if ( $address['postcode'] && ! \WC_Validation::is_postcode( $address['postcode'], $address['country'] ) ) {
                throw new \Exception( __( 'Please enter a valid postcode / ZIP.', 'woocommerce' ) );
            } elseif ( $address['postcode'] ) {
                $address['postcode'] = wc_format_postcode( $address['postcode'], $address['country'] );
            }

            if ( $address['country'] ) {
                if ( ! WC()->customer->get_billing_first_name() ) {
                    WC()->customer->set_billing_location( $address['country'], $address['state'], $address['postcode'], $address['city'] );
                }
                WC()->customer->set_shipping_location( $address['country'], $address['state'], $address['postcode'], $address['city'] );
            } else {
                WC()->customer->set_billing_address_to_base();
                WC()->customer->set_shipping_address_to_base();
            }

            WC()->customer->set_calculated_shipping( true );
            WC()->customer->save();

            do_action( 'woocommerce_calculated_shipping' );

        } catch ( \Exception $e ) {
            if ( ! empty( $e ) ) {
                wc_add_notice( $e->getMessage(), 'error' );
            }
        }
    }
}
