<?php

namespace Moneris\Checkout;

use Moneris\Checkout\Helper\Data;

class Bootstrap
{
    public function init()
    {
        if ($this->check_end_point()) {
            $api = new Api();
            $api->execute();
            exit;
        }
        //load_plugin_textdomain('moneris-checkout-woocommerce', null, MONERIS_WC_PLUGIN_DIR . '/languages' );
        $gateway = new \Moneris\Checkout\Gateway();
        new \Moneris\Checkout\Controller\Checkout();
        new \Moneris\Checkout\Controller\Email();
        add_filter('woocommerce_payment_gateways', [$gateway, 'add_moneris_checkout_method']);
        add_action('carbon_fields_container_moneris_checkout_account_details_before_fields', [$this, 'add_moneris_checkout_introduction']);
    }

    public function check_end_point()
    {
        $endpoint = trim($_SERVER['REQUEST_URI'], '/');

        if ( strpos( $endpoint, 'moneris-checkout-wc' ) === 0 ) {
            return true;
        }

        return false;
    }

    public function add_moneris_checkout_introduction()
    {
    	?>
		<p><img src='https://www.moneris.com/-/media/Moneris/Files/EN/Moneris-Logos/Moneris_MD_BIL_CMYK_2016.ashx?h=59&w=166&hash=5E684F4C56A2FFCA6DA0A48FDC19C909'/><br><b>Accept payments on your website</b>
			<br>
			With Moneris Checkout, a
			comprehensive online payment solution,
			you can easily and securely process
			customer transactions on your website.
			Bring the power of ecommerce to your
			website with Moneris Checkout.
			<br><br>
			Don’t have an account with Moneris
			yet? It’s easy to get started. Call
			Moneris at 1-855-232-2365 and mention
			configuration code ECNP-00493.</p>
		<?php
    }
}
