<?php

namespace Moneris\Checkout\Controller;

use Moneris\Checkout\Gateway;

class Checkout
{
    public function __construct() {
        $this->load_hooks();
    }

    public function load_hooks() {
        add_filter('woocommerce_order_button_html', [$this, 'add_moneris_checkout_button']);
        add_filter('woocommerce_review_order_before_submit', [$this, 'get_js_config']);
    }

    public function add_moneris_checkout_button($button) {
        $available_gateways = WC()->payment_gateways->get_available_payment_gateways();

        if (empty($available_gateways)) {
            return $button;
        }

        $selected = false;
        $hidden = '';

        foreach ($available_gateways as $gateway) {
            if ($gateway instanceof Gateway && $gateway->chosen === true) {
                $selected = true;
            }
        }

        if ($selected) {
            $button .= '<script>document.getElementById("place_order").style.display = "none";</script>';
        } else {
            $hidden = 'style="display: none"';
        }

        $order_button_text = __('Place order');
        $button .= '<button ' . $hidden . ' type="button" class="button alt" name="woocommerce_moneris_checkout_place_order" id="moneris_place_order" value="checkout_with_moneris_checkout">' . esc_html( $order_button_text ) . '</button>';

        return $button;
    }

    public function get_js_config()
    {
        $ticket      = new \Moneris\Checkout\Ticket();
        $template    = new \Moneris\Checkout\Template();
//        $ticketData  = $ticket->getTicket();
        ?>
        <div>
        <?php
            echo $template->display_template( 'checkout.phtml' );
        ?>
        </div>
        <?php
    }
}
