const $ = jQuery;
const urlBuilder = {
    build: function (path) {
        var baseUrl = window.MonerisCheckoutConfig.base_url;
        return baseUrl + '/' + path;
    }
};

const fullScreenLoader = {
    startLoader: function () {

    },
    stopLoader: function () {

    },
};
window.MonerisCheckoutWC = {

    defaults: {
        template: 'Moneris_MonerisCheckout/button-in-cart'
    },

    cartId: null,

    isMonerisCheckoutActive: function () {
        return true;
    },

    initialize: function () {
        this._super();

        if (
            $('body').hasClass('checkout-index-index') ||
            $('body').hasClass('checkout-cart-index')
        ) {
            this.isInCheckoutPages = true;
        }

    },

    showReceipt: false,
    processedOrder: false,
    myCheckout: {},
    formattedAddress: {},
    isInCheckoutPages: false,
    configureButton: function () {
        if (typeof window.MonerisCheckoutConfig === 'undefined') {
            return;
        }
        var self = this;
        window.$ = $;
        $(document).ready(function () {
            self.myCheckout = new monerisCheckout();
            var res = {};

            if (window.MonerisCheckoutConfig.mode == 'qa') {
                self.myCheckout.setMode("dev");
            } else {
                self.myCheckout.setMode("prod");
            }

            self.myCheckout.setCheckoutDiv("monerisCheckout");

            self.myCheckout.setCallback("cancel_transaction", myCancelTransaction);
            self.myCheckout.setCallback("payment_receipt", myPaymentReceipt);
            self.myCheckout.setCallback("payment_complete", myPaymentComplete);
            self.myCheckout.setCallback("error_event", myErrorEvent);
            self.myCheckout.setCallback("page_loaded", myPageLoad);

            self.myCheckout.logConfig();

            function myCancelTransaction(data) {
                if (self.showReceipt === true) {
                    self.myCheckout.closeCheckout();
                    console.log(data);
                } else {
                    self.myCheckout.closeCheckout();
                }
            }

            function myPaymentComplete(data) {
                data = JSON.parse(data);

                if (self.showReceipt === true) {
                    if (!self.processedOrder) {
                        $('#moneris_checkout_receipt_id_input').val(data.ticket);
                        $('#place_order').click();
                    }
                    self.myCheckout.closeCheckout();
                    console.log(data);
                } else {
                    self.myCheckout.closeCheckout();
                    $('#moneris_checkout_receipt_id_input').val(data.ticket);
                    $('#place_order').click();
                }
            }

            function myPaymentReceipt(data) {
                self.showReceipt = true;
                self.receipt = data.ticket;
                fullScreenLoader.startLoader();
                console.log('payment receipt');
                console.log(data);
                var json = JSON.parse(data);
                var urlXhr = urlBuilder.build('moneris-checkout-wc?type=pay');

                $.post(urlXhr, json, function (data) {
                    if (data.success) {
                        self.chargeRequest(data.data.request);
                    } else {
                        alert(data.message);
                        self.myCheckout.closeCheckout();
                    }
                }, "json");
            }

            function myErrorEvent() {
                console.log('error');
                self.myCheckout.closeCheckout();
                window.location.href = window.MonerisCheckoutConfig.shop_url;
            }

            function myPageLoad(data) {
                console.log(data);
                var load = JSON.parse(data);
            }
        });
    },

    initButton: function () {

        var self = this;

        $('body').append('<div id="monerisCheckout" style="z-index: 9999"></div>');

        if (window.MonerisCheckoutConfig.mode == 'qa') {
            var url = "https://gatewayt.moneris.com/chkt/js/chkt_v1.00.js";
        } else {
            var url = "https://gateway.moneris.com/chkt/js/chkt_v1.00.js";
        }

        $.getScript(url, function () {
            self.configureButton();
        });
    },

    chargeRequest: function (ev) {
        var self = this;

        self.makeOrder(ev);
    },

    makeOrder: function (ev) {
        self.processedOrder = true;
        $('#moneris_checkout_receipt_id_input').val(ev.ticket);
        $('#place_order').click();
        setTimeout(
            function () {
                self.myCheckout.closeCheckout();
            }, 7500);
    },

    showMonerisButton: function () {
        $('#place_order').hide();
        $('#moneris_place_order').show();
    },

    hideMonerisButton: function () {
        $('#moneris_place_order').hide();
        $('#place_order').show();
    },

    addEventListeners: function () {
        var self = this;
        $(document).on('payment_method_selected', function () {
            var selected_payment = jQuery('.woocommerce-checkout input[name="payment_method"]:checked').attr("id");

            if (selected_payment == 'payment_method_moneris_checkout_woocommerce') {
                self.showMonerisButton();
            } else {
                self.hideMonerisButton();
            }
        });

        $(document).on('click', '#moneris_place_order', function () {
            var checkout_form = jQuery("form.checkout");
            $('#customer_details .form-row').removeClass('woocommerce-invalid');
            $('.validate-required select, .validate-required input').trigger('validate');
            checkout_form.trigger('validate');

            if (!$('#ship-to-different-address-checkbox').prop('checked')) {
                $('#customer_details .woocommerce-shipping-fields .form-row').removeClass('woocommerce-invalid');
            }

            if (checkout_form.find('.woocommerce-billing-fields .form-row.woocommerce-invalid, woocommerce-shipping-fields .form-row.woocommerce-invalid').length > 0) {
                return;
            }

            $.blockUI({
                message: null,
                overlayCSS: {
                    background: '#fff',
                    opacity: 0.6
                }
            });
            var dataXhr = {
                billing_first_name: $('#billing_first_name').val(),
                billing_last_name: $('#billing_last_name').val(),
                billing_email: $('#billing_email').val(),
                billing_phone: $('#billing_phone').val(),
            };
            var urlXhr = urlBuilder.build('moneris-checkout-wc?type=getticket');
            $.post(urlXhr, dataXhr, function (response) {
                $.unblockUI();
                if (response.success === true && typeof response.data.ticket !== 'undefined') {
                    self.myCheckout.startCheckout(response.data.ticket);
                } else {
                    var error_msg = '';

                    if (typeof response.data.error !== 'undefined') {
                        for (var i = 0; i < response.data.error.length; i++) {
                            error_msg += response.data.error[i].data + '\n';
                        }

                        alert(error_msg);
                    }
                }
            }, 'json');
        });
    }
};

window.MonerisCheckoutWC.initButton();
window.MonerisCheckoutWC.addEventListeners();
